#!/bin/sh -x

MOUNT_POINT=/autofs

HP_DEV=${DEVPATH##*/}
DEV="/dev/$HP_DEV"
if [ "$ACTION" == "add" ]; then
	line="`blkid | grep \"^$DEV:\"`"
	if [ "${DEV:0:7}" == "/dev/sd" ]; then
		DEV_BLOCK="${DEV:5:3}"
		DEV_INFO="`echo \"$line\" | cut -d: -f2-`"
		for o in $DEV_INFO; do
			case "$o" in
			LABEL=*)	DEV_LABEL=${o#LABEL=};;
			UUID=*)		DEV_UUID=${o#UUID=};;
			TYPE=*)		DEV_TYPE=${o#TYPE=};;
			esac
		done
		DEV_LABEL="`echo \"$DEV_LABEL\" | sed 's/"//g'`"
		if [ -z "$DEV_LABEL" ]; then
			DEV_LABEL=Disk
		fi
		DIR="$MOUNT_POINT/$DEV_LABEL (${DEV:5})"
		while [ -d "$DIR" ]; do
			DIR="${DIR}_"
		done
		#MOUNT_INFO="`cat /proc/mounts | grep \"^$DEV \" | grep \" $MOUNT_POINT\"`"
		#if [ -z "$MOUNT_INFO" ]; then
		#	MOUNTED=0
		#else
		#	MOUNTED=1
		#	#MOUNT_PATH="`echo \"$MOUNT_INFO\" | cut -d\  -f2`"
		#	#MOUNT_PATH="`echo -e \"$MOUNT_INFO\"`"
		#fi
		mount_opts="-o rw"
		#if [ $MOUNTED == 0 ];then
			mkdir "$DIR"
			if [ "`cat /sys/block/$DEV_BLOCK/removable`" == "1" ]; then
				mount_opts="$mount_opts,sync,dirsync"
			fi
			mount $mount_opts "$DEV" "$DIR"
			if [ ! $? == 0 ]; then
				rmdir "$DIR"
			fi
		#fi
		#mount $mount_opts "$DEV" "$DIR"
	fi
elif [ "$ACTION" == "remove" ]; then
	#MOUNT_INFO="`cat /proc/mounts | grep \"^$DEV \" | grep \" $MOUNT_POINT\"`"
	umount "$DEV"
	#if [ ! -z "$MOUNT_INFO" ]; then
	#	MOUNT_PATH="`echo \"$MOUNT_INFO\" | cut -d\  -f2`"               
	#	MOUNT_PATH="`echo -e \"$MOUNT_INFO\"`"
	#	rmdir "$MOUNT_PATH"
	#fi
	rmdir "$MOUNT_POINT"/*\($HP_DEV\)*
fi
